<?php
// Name: config.php
// Description: This file contains settings used to configure the system
// Author: Martin Green
// Version: 1.2
// Last Modified: 03/06/2007


// ######## System Settings ########

// full path of FFMPEG executable
$ffmpeg = "/usr/local/bin/ffmpeg";

// time index to take preview image, format is HH:MM:SS
$preview_time = "00:00:15";

// remove cache files older than X days, 0 for infinite
$cache_age = 10;

// enable remote cache upload facility
$remote_cache = true;

// enable source file download
$source_download = true;

// enable cache statistics, also removes link to clear cache
$cache_stats = true;

// list of valid file extensions for videos, uppercase
$video_types = array("AVI", "MPG", "MPEG", "MOV");

// list of characters to replace with space in names
//   this improves the clarity of names and allows wordwrap
$replace_chars = array("_", ".");


// ######## Directory Settings ########

// directory where video files are stored
$basedir = "/data/video";

// directory where log files should be stored during encoding
$logdir = "/tmp";

// directory where encoded flv files should be stored
$flv_cache = "/srv/www/htdocs/video/cache";
$flv_url = "/video/cache";

// directory where preview images should be stored
$image_cache = "/srv/www/htdocs/video/cache";
$image_url = "/video/cache";

// directory where video information files should be stored
$info_cache = "/srv/www/htdocs/video/cache";


// ######## Remote Cache Settings ########

// remote cache ftp server and path
$remote_server = "ftp.domain.co.uk";
$remote_path = "/cache";

// remote cache url
$remote_url = "http://www.domain.co.uk/swvidc/cache";

// remote ftp login settings
$remote_user = "swvidc";
$remote_pass = "password";


// ######## Interface Settings ########

// default style sheet to use
$default_style = "Normal";
//$default_style = "Wii";

// check if user has set style
if (isset($_GET['style'])) {
  $style = $_GET['style'];
} else {
  $style = $default_style;
}  

// set view parameters depending on style
if ($style == "Normal") {
  // number of folders and videos to show per row
  $dir_row = 5;
  $video_row = 3;
} elseif ($style == "Wii") {
  // number of folders and videos to show per row
  $dir_row = 4;
  $video_row = 2;
} else {
  // number of folders and videos to show per row
  $dir_row = 5;
  $video_row = 3;
}
?>