<?php
// Name: encode.php
// Description: This file runs FFMPEG with the chosen video and
//   quality values to create the flv file.
// Author: Martin Green
// Version: 1.1
// Last Modified: 23/05/2007

// return user to previous page when done
if (isset($_SERVER['HTTP_REFERER'])) {
  header("Location: " . $_SERVER['HTTP_REFERER']);
} else {
  header("Location: index.php");
}

require_once("config.php");

// set command to be run
$command = $ffmpeg;

// set input file name
if (isset($_GET['file'])) {
  $file = $_GET['file'];
  $command .= " -i \"$file\" -f flv";
} else {
  exit;
}

// get selected video quality
if (isset($_GET['vquality'])) {
  $quality = $_GET['vquality'];
} else {
  $quality = "low";
}

// add video settings
if ($quality == "full") {
  // same quality as source
  $command .= " -sameq";
} elseif ($quality == "high") {
  $command .= " -b 600kb/s";
} elseif ($quality == "med") {
  $command .= " -r 20";
  $command .= " -b 300kb/s";
} elseif ($quality == "low") {
  $command .= " -r 20";
  $command .= " -b 100kb/s";
}

// get selected audio quality
if (isset($_GET['aquality'])) {
  $quality = $_GET['aquality'];
} else {
  $quality = "low";
}

// add audio settings
if ($quality == "high") {
  $command .= " -ar 44100";
  $command .= " -ab 64kb/s";
} elseif ($quality == "low") {
  $command .= " -ar 22050";
  $command .= " -ab 32kb/s";
}
  
// get selected resolution
if (isset($_GET['res']) && isset($_GET['resval'])) {
  $res = $_GET['res'];
  $resval = $_GET['resval'];
  
  // add resolution settings
  if ($res == "full") {
    // keep source resolution
  } elseif ($res == "3qrt") {
    $pos = strpos($resval, 'x');
    $width = substr($resval, 0, $pos);
    $height = substr($resval, $pos + 1, strlen($resval) - $pos);
    // calculate 3/4 height and width
    $width = intval($width) * 0.75;
    $height = intval($height) * 0.75;
    
    $command .= " -s " . $width . "x" . $height;
  } elseif ($res == "half") {
    $pos = strpos($resval, 'x');
    $width = substr($resval, 0, $pos);
    $height = substr($resval, $pos + 1, strlen($resval) - $pos);
    // calculate 1/2 height and width
    $width = intval($width) * 0.5;
    $height = intval($height) * 0.5;
    
    $command .= " -s " . $width . "x" . $height;
  }
}

$filehash = md5($file);

// set output and log files
$command .= " -y \"$flv_cache/$filehash.flv\"";
$command .= " &> \"$logdir/$filehash.log\"";

// run FFMPEG
exec($command);

// remove log file
unlink("$logdir/$filehash.log");
?>