<?php
// Name: index.php
// Description: This file displays the list of videos and provides
//   access to encoding and viewing
// Author: Martin Green
// Version: 1.5
// Last Modified: 02/06/2007


// include config and function library
require_once("config.php");
require_once("_lib_swvidc.php");

if (isset($_GET['dir'])) {
  $dir = $_GET['dir'];
  // ensure dir starts with basedir
  //   this is done for security
  //   can include other folders using symlinks under the base directory
  if (strpos($dir, $basedir) === false) {
    $dir = $basedir;
  }
} else {
  $dir = $basedir;
}

// check cache_age to see if automatic deletion should be run
if ($cache_age > 0) {
  clearflvcache();
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-gb">
<head>
<meta content="text/html; charset=ISO-8859-1" http-equiv="content-type" />
<link type="text/css" href="styles/<?php print $style; ?>.css" rel="stylesheet" />
<title>StealthWare Video Converter</title>
</head>
<body>
<p class="title"><img src="images/swlogo.png" alt="StealthWare"></img> Video Converter v1.0</p>

<p class="section">Quality Settings</p>

<form method="get" action="">
<div><input type="hidden" name="dir" value="<?php print $dir; ?>" />
<input type="hidden" name="style" value="<?php print $style; ?>" /></div>
<table class="settings" cellpadding="4" cellspacing="0"><tbody>
<tr>
<td class="settings">
Resolution: <select name="res">
<option selected="selected" value="full">Full</option>
<option value="3qrt">3 Quarter</option>
<option value="half">Half</option>
</select>
</td>
<td class="settings">
Video Quality: <select name="vquality">
<option selected="selected" value="full">Full</option>
<option value="high">High</option>
<option value="med">Medium</option>
<option value="low">Low</option>
</select>
</td>
<td class="settings">
Audio Quality: <select name="aquality">
<option selected="selected" value="high">High</option>
<option value="low">Low</option>
</select>
</td>
<td class="settings">
<input type="submit" name="set" value="Set" />
</td>
</tr>
</tbody></table>
</form>

<form method="get" action="">
<div><input type="hidden" name="dir" value="<?php print $dir; ?>" />
<input type="hidden" name="res" value="<?php print $_GET['res']; ?>" />
<input type="hidden" name="vquality" value="<?php print $_GET['vquality']; ?>" />
<input type="hidden" name="aquality" value="<?php print $_GET['aquality']; ?>" /></div>
<table class="settings" style="width: 300px;" cellpadding="4" cellspacing="0"><tbody>
<tr>
<td class="settings">
Style: <select name="style">
<option selected="selected" value="Normal">Normal</option>
<option value="Wii">Wii</option>
</select>
</td>
<td class="settings">
<input type="submit" name="set" value="Set" />
</td>
</tr>
</tbody></table>
</form>

<p class="section">Folders</p>

<table class="folder" cellpadding="4" cellspacing="8"><tbody>
<tr>
<?php

  $pos = strrpos($dir, '/');
  $newdir = substr($dir, 0, $pos);
  $link = "?dir=" . $newdir;
    
  // set link to preserve quality or style settings
  if (isset($_GET['vquality']) && isset($_GET['aquality']) && isset($_GET['res'])) {
    $link .= "&&amp;vquality=" . $_GET['vquality'] . "&amp;aquality=" . $_GET['aquality'] . "&amp;res=" . $_GET['res'];
  }
  if (isset($_GET['style'])) {
    $link .= "&amp;style=" . $_GET['style'];
  }
  
?>
<td class="folder">
<a href="<?php print $link; ?>"><img alt="Folder" title="Parent Directory" src="images/folderup.png" /></a><br />
<a href="<?php print $link; ?>">Parent Directory</a>
</td>
<?php

// Display list of folders
$indx = 1;
foreach (listdir($dir) as $item) {

  // start new row
  if ($indx == 0) {
 	  print "<tr>\n";
  }
  
    $indx++;
    $name = str_replace($replace_chars, " ", $item); // replace rubbish in names
    $link = "?dir=$dir/$item";
    $image = "images/folder.png";
    
    // set link to preserve quality or style settings
    if (isset($_GET['vquality']) && isset($_GET['aquality']) && isset($_GET['res'])) {
      $link .= "&amp;vquality=" . $_GET['vquality'] . "&amp;aquality=" . $_GET['aquality'] . "&amp;res=" . $_GET['res'];
    }
    if (isset($_GET['style'])) {
      $link .= "&amp;style=" . $_GET['style'];
    }
    
?>
<td class="folder">
<a href="<?php print $link; ?>"><img alt="Folder" title="<?php print $name; ?>" src="<?php print $image; ?>" /></a><br />
<a href="<?php print $link; ?>"><?php print $name; ?></a>
</td>
<?php
  
  // row limit reached, start new row
  if ($indx == $dir_row) {
 	  print "</tr>\n";
  	  $indx = 0;
  }
}

// if needed, finish this row
if ($indx != $dir_row && $indx != 0) {
  print "</tr>\n";
}
?>
</tbody></table>

<p class="section">Video Files</p>

<table cellpadding="0" cellspacing="8"><tbody>
<?php

// Display list of Videos
$indx = 0;
foreach (listvideo($dir) as $file) {

  // start new row
  if ($indx == 0) {
 	  print "<tr>\n";
  }

  $name = "";
  $link = "";
  $image = "";
  $size = "";
  $length = 0.0;
  $res = "";
  $fps = "";

    $indx++;
    
    // create md5 hash from file name
    $filehash = md5("$dir/$file");
  
    // get name from file and replace any rubbish chars
    $name = str_replace($replace_chars, " ", substr($file, 0, strrpos($file, ".")));
    $link = "download.php?dir=$dir&amp;file=$file"; // set the download link
  	 $type = substr($file, (strrpos($file, ".")+1)); // get type extension from file name
 	 $size = round((filesize("$dir/$file") / 1024 ) / 1024, 2) . " MB"; // get file size
 	 $image = $image_cache . "/" . $filehash . "1.jpg"; // set image locations
 	 $imageurl = $image_url . "/" . $filehash . "1.jpg";
 	 $infofile = "$info_cache/$filehash.info";
 	
    // generate info file, if needed
 	 if (!file_exists($infofile)) {
 	   // run ffmpeg with no arguments to get it to output basic info about the video
      $command = "$ffmpeg -i \"$dir/$file\" &> \"$infofile\"";
      exec($command);
    }
  
    // load details from info file
    $handle = fopen($infofile, 'r');
    while (!feof($handle)) {
      $content = fgets($handle);
      $bits = explode(' ', $content);
      for ($i = 0; $i < count($bits); $i++) {
        // get duration
        if ($bits[$i] == "Duration:") {
          $length = video_length($bits[$i+1]);
        }
        // get resolution
        if ($bits[$i] == "Video:") {
          $res = substr($bits[$i+3], 0, -1);
        }
        // get frame rate
        if (!(strpos($bits[$i], "fps(r)") === false)) {
          $fps = round(floatval($bits[$i-1]));
        }
      }
    }
    fclose($handle);
  
    // generate preview image
 	 if (!file_exists($image)) {
 	   // run ffmpeg to generate preview image
 	   $command = "$ffmpeg -i \"$dir/$file\" -an -ss $preview_time -t $preview_time -vframes 1 -r 1 -y \"$image_cache/$filehash%d.jpg\"";
 	   @exec($command, $out, $ret);
 	   // if an error occurs or the file still doesnt exist, set the image to default
 	   if ($ret != '0' || !file_exists($image)) {
        $imageurl = "images/nopreview.png";
      }
    }

?>
<td><table class="video" cellpadding="2" cellspacing="2"><tbody>
<tr><td class="vidimage" colspan="1" rowspan="4" align="center">
<a href="<?php print $imageurl; ?>">
<img alt="Preview" class="preview" title="<?php print $file; ?>" src="<?php print $imageurl; ?>" />
</a></td>
<td class="video">Size: <?php print $size; ?></td></tr>
<tr><td class="video">Resolution: <?php print $res; ?></td></tr>
<tr><td class="video">Length: <?php print floor($length / 60); ?> mins <?php print round(fmod($length, 60)); ?> secs</td></tr>
<tr><td class="video">FPS: <?php print $fps; ?></td></tr>
<tr><td class="video" colspan="2" rowspan="1">
<?php
if ($source_download) {
print "<a href=\"$link\">$name</a>";
} else {
print $name;
}
?>
</td></tr>
<tr><td class="video" colspan="2" rowspan="1">
<?php

    // display some links, depending on what files are available
    if (file_exists("$flv_cache/$filehash.flv")) {
      if (file_exists("$logdir/$filehash.log")) {
        // video is currently being encoded so display progress
        $time = progress("$logdir/$filehash.log");
        print "Encoding: " . round(($time / $length) * 100) . "%";
      } else {
        // video has been encoded so display link to player
        print "<a href=\"player.php?file=$flv_url/$filehash.flv&amp;image=$imageurl\">View</a>";
        
        // display links/status for remote cache, if enabled
        if ($remote_cache) {
          if (file_exists("$flv_cache/$filehash.remote")) {
            // file has been uploaded so display link to play remote file
            print "&nbsp;|&nbsp;<a href=\"player.php?file=$remote_url/$filehash.flv&amp;image=$imageurl\">View Remote</a>";
          } elseif (file_exists("$logdir/$filehash" . "_upload.log")) {
            // file is currently uploading, so display message
            print "&nbsp;|&nbsp;Uploading";
          } else {
            // display link to upload file
            print "&nbsp;|&nbsp;<a href=\"upload.php?filehash=$filehash\">Upload</a>";
          }
        }
        
        // display link to delete cache
        print "&nbsp;|&nbsp;<a href=\"cache.php?filehash=$filehash\">Delete</a>";
      }
    } else {
      // display link for encoding video
      print "<a href=\"encode.php?file=$dir/$file&amp;vquality=" . $_GET['vquality'] . "&amp;aquality=" . $_GET['aquality'] . "&amp;res=" . $_GET['res'] . "&amp;resval=$res\">Encode</a>";
    }
    
?>
</td></tr>
</tbody></table></td>
<?php
  // row limit reached, start new row
  if ($indx == $video_row) {
 	 print "</tr>\n";
    $indx = 0;
  }
}

// if needed, finish this row
if ($indx != $video_row && $indx != 0) {
  print "</tr>\n";
}
?>
</tbody></table>
<?php
if ($cache_stats) {
  // calculate cache stats
  $vcache_size = 0;
  $vcache_quantity = 0;
  $icache_size = 0;
  $icache_quantity = 0;

  $dh = opendir($flv_cache);
  // loop through directory list
  while (($file = readdir($dh)) !== false) {
    // check this is a file
    if (is_file("$flv_cache/$file")) {
        // get file extension
        $type = substr($file, (strrpos($file, ".")+1));
        if ($type == "flv") {
          $vcache_size += filesize("$flv_cache/$file");
          $vcache_quantity++;
        }
    }
  }
  closedir($dh);

  $dh = opendir($image_cache);
  // loop through directory list
  while (($file = readdir($dh)) !== false) {
    // check this is a file
    if (is_file("$image_cache/$file")) {
        // get file extension
        $type = substr($file, (strrpos($file, ".")+1));
        if ($type == "jpg") {
          $icache_size += filesize("$image_cache/$file");
          $icache_quantity++;
        }
    }
  }
  closedir($dh);

  $dh = opendir($info_cache);
  // loop through directory list
  while (($file = readdir($dh)) !== false) {
    // check this is a file
    if (is_file("$info_cache/$file")) {
        // get file extension
        $type = substr($file, (strrpos($file, ".")+1));
        if ($type == "info") {
          $icache_size += filesize("$info_cache/$file");
          $icache_quantity++;
        }
    }
  }
  closedir($dh);

?>
<p style="text-align:center">Video cache size <?php print round(($vcache_size / 1024 ) / 1024, 2) . " MB"; ?>, <?php print $vcache_quantity; ?> files. Image and Information cache size <?php print round(($icache_size / 1024 ) / 1024, 2) . " MB"; ?>, <?php print $icache_quantity; ?> files.<br />
<a href="cache.php?clear">Clear Video Cache</a> | <a href="cache.php?clearall">Clear All Cache</a></p>
<?php
}
?>
</body>
</html>