<?php
// Name: upload.php
// Description: This file uploads the video to the remote server
// Author: Martin Green
// Version: 1.0
// Last Modified: 23/05/2007

require_once("config.php");

// return user to previous page when done
// Note: this page does not produce any output even for errors, just returns
if (isset($_SERVER['HTTP_REFERER'])) {
  header("Location: " . $_SERVER['HTTP_REFERER']);
} else {
  header("Location: index.php");
}

// get the id of the file to upload
if (isset($_GET['filehash'])) {
  $filehash = $_GET['filehash'];
} else {
  exit;
}

// connect and login to the remote ftp server
$conn = ftp_connect($remote_server);
$login = ftp_login($conn, $remote_user, $remote_pass);

// check the connection
if (!$conn || !$login) {
  exit;
}

// create log file, shows main page that upload is in progress
touch("$logdir/$filehash" . "_upload.log");

// put the file
$ret = ftp_put($conn, "$remote_path/$filehash.flv", "$flv_cache/$filehash.flv", FTP_BINARY);

// remove log file
unlink("$logdir/$filehash" . "_upload.log");

// check if upload was successful
if (!$ret) {
  exit;
}

// close connection
ftp_close($conn);

// create flag file to inform system that upload was done
touch("$flv_cache/$filehash.remote");
?>